#include <stdio.h>
struct esame {
       long matricola;
       char data[12];
       int voto;
       };
       
void inserisci(struct esame *V, int *pn);
void visualizza(struct esame *V, int n);
void salva(struct esame *V, int n);
void carica(struct esame *V, int *pn);

main() {
 struct esame *VE;
 int n,dim, opzione;
 
 printf("Dim vettore: ");
 scanf("%d",&dim);
 VE=(struct esame *) malloc(dim*sizeof(struct esame));
 if (VE==NULL)
   exit(1);
 
 n=0;
 do {
     printf("Scegli una delle seguentio opzioni\n");
     printf("1) Inserimento\n2) Visualizzazione\n");
     printf("3) Salvataggio\n4) Caricamento da file\n");
     printf("0) fine esecuzione\n");
     scanf("%d",&opzione);
     switch(opzione) {
     case 1: /* inserimento*/
                inserisci(VE,&n);
                break;
     case 2:  /* visualizzazione*/
                visualizza(VE,n);
                break;
    case 3:  /* salvataggio su file */
              salva(VE,n);
              break;
     case 4:  carica(VE,&n);
              break;
     default:; }
   } while (opzione!=0);
   
   free(VE);
}

void inserisci(struct esame *V, int *pn)
{
  struct esame x;
  
  if(*pn<dim)
  {
   /* lettura esame da inserire */
   printf("Matricola: ");
   scanf("%ld",&x.matricola);
   printf("Data esame: ");
   scanf("%s",x.data);
   printf("Voto: ");
   scanf("%d",&x.voto);
   V[*pn]=x; 
   (*pn)++;
  } 
  else printf("Vettore pieno\n");
}

void visualizza(struct esame *V, int n)
{
     int i;
     
     for(i=0;i<n;i++)
     {  printf("Matricola: %ld\n",V[i].matricola);
        printf("Data esame: %s\n",V[i].data);
        printf("Voto: %d\n",V[i].voto);
     }   
}     
    
void salva(struct esame *V, int n)
{
   FILE *pf;
   int i;
   char nomefile[80];
   
   printf("Nome file\n");
   scanf("%s",nomefile);
   pf=fopen(nomefile,"w");
   if(pf) {
            for(i=0;i<n;i++)
              fwrite(&V[i],sizeof(struct esame),1,pf);
             fclose(pf);
          }
}
          
     
void carica(struct esame *V, int *pn)
{
   FILE *pf;
   char nomefile[80];
   struct esame x;
   
   printf("Nome file: ");
   scanf("%s",nomefile);
   pf=fopen(nomefile,"r");
   if(pf) 
     {  while(*pn<dim && fread(&x,sizeof(struct esame),1,pf)!=0) 
        {  
           V[*pn]=x;
           (*pn)++;
        } 
        fclose(pf);
     }
   else printf("Il file non esiste\n");  
}              
               
     
     
     
     
     
     
     
 
 







