#include <stdio.h>
#include <stdlib.h>

struct coordinata {
       int x,y;
       };
       
void leggi(struct coordinata *c);
void inserisci(struct coordinata **Vf, int *pn, struct coordinata el);
void visualizza(struct coordinata *Vf, int n);
void salva(struct coordinata *Vf, int n);
void carica(struct coordinata **Vf, int *pn);
void elimina(struct coordinata **Vf, int *pn);


main() {
 struct coordinata *V, el;
 int n, scelta;
 n=0;
 V=NULL;
 
 do {
     printf("Scegli tra: \n");
     printf("1) carica\n2) salva\n");
     printf("3) inserisci\n4) visualizza\n");
     printf("5) Elimina\n");
     printf("0) fine\n");
     scanf("%d",&scelta);
     switch(scelta) {
     case 3:  /* inserimento*/
              leggi(&el);
              inserisci(&V,&n,el);
              break;
     case 4: /* visualizzazione*/
              visualizza(V,n);
              break;
     case 1:  carica(&V,&n);
              break;
     case 2:  salva(V,n);
              break;
     case 5:  elimina(&V,&n);
              break;
     default:; }
     } while(scelta!=0);
     
     
     
     free(V);
}
void leggi(struct coordinata *c)
{
  printf("X: ");
  scanf("%d",&(*c).x);
  printf("Y: ");
  scanf("%d",&(*c).y);
  
  /* oppure
  printf("X: ");
  scanf("%d",&c->x);
  printf("Y: ");
  scanf("%d",&c->y);
  */
}  
  
       

void inserisci(struct coordinata **Vf, int *pn, struct coordinata el)
{
     struct coordinata *Va;
     
     Va= (struct coordinata *) realloc(*Vf,(*pn+1)*sizeof(struct coordinata));
     if(Va==NULL)
         return;
     *Vf=Va;
     (*Vf)[*pn]=el;
     (*pn)++;
}

void carica(struct coordinata **Vf, int *pn)
{
     FILE *pf;
     char nomefile[80];
     struct coordinata el;
     
     printf("Nome file ");
     scanf("%s",nomefile);
     pf=fopen(nomefile,"r");
     if(pf) {
              while(fread(&el,sizeof(struct coordinata),1,pf)!=0) 
                inserisci(Vf,pn,el);
              fclose(pf);
              }
      else printf("Il file non esiste\n");
}      
   
void visualizza(struct coordinata *Vf, int n)
{ int i;
  
    for(i=0;i<n;i++)
      printf("X=%d  Y=%d\n",Vf[i].x,Vf[i].y);
}
    
    
void salva(struct coordinata *Vf, int n)
{  
     FILE *pf;
     char nomefile[80];
     
     printf("Nome file ");
     scanf("%s",nomefile);
     pf=fopen(nomefile,"w");
     if(pf) {
              fwrite(Vf,sizeof(struct coordinata),n,pf);
              fclose(pf);
              }
}

void elimina(struct coordinata **Vf, int *pn)
{
   struct coordinata c;
   int i,p;
   
   printf("X: ");
   scanf("%d",&c.x);
   printf("Y: ");
   scanf("%d",&c.y);
   /* ricerca l'elemento di valore c */
   for(p=0;p<*pn;p++)         
     if((*Vf)[p].x==c.x && (*Vf)[p].y==c.y)
         break;
   
   /* eliminazione */
   if(p<*pn) /* l'elemento e' stato trovato */
    {  for(i=p;i<*pn-1;i++)
         (*Vf)[i]=(*Vf)[i+1];
      (*pn)--;
      
      *Vf= (struct coordinata *) realloc(*Vf,(*pn)*sizeof(struct coordinata));
    }
   else printf("Elemento non trovato\n");
} 
      
   
     
         
